<?php

/*
    This file is a part of DAlbum.  Copyright (c) 2003 Alexei Shamov, DeltaX Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
    if (!defined("DALBUM_ROOT"))
        define("DALBUM_ROOT",".");
    if (!defined("DALBUM_BROWSERROOT"))
        define("DALBUM_BROWSERROOT","");

    define("DALBUM_CONFIGPG_PAGE","1");

    require_once(DALBUM_ROOT . "/include/functions.php");
    require_once(file_exists(DALBUM_ROOT."/config/config.php")?DALBUM_ROOT."/config/config.php":DALBUM_ROOT."/include/config.php");
    require_once(DALBUM_ROOT."/include/conffix.php");
    require_once(DALBUM_ROOT."/include/createhta.php");
    require_once(DALBUM_ROOT."/include/createini.php");
    require_once(DALBUM_ROOT."/include/album.php");

    // Include custom functions
    if (file_exists(DALBUM_ROOT . "/config/custom.php"))
        include_once(DALBUM_ROOT . "/config/custom.php");
    elseif (file_exists(DALBUM_ROOT . "/include/custom.php"))
        include_once(DALBUM_ROOT . "/include/custom.php");

    remove_bloody_magic_quotes();

    $sUserName=StartSessionAndGetUserName('private; must-revalidate');
    if (function_exists('everypageCallback'))
        everypageCallback($sUserName);


    $url="";
    if (isset($_POST['url']))
        $url=$_POST['url'];
    if (empty($url) && isset($_GET['url']))
        $url=@$_GET['url'];
    if (empty($url))
        $url=base64_encode(translateRef("index.php"));

    $sTarget=base64_decode($url);

    if (!isAdminMode($sUserName) || isset($_POST['cancel']))
    {
        dalbum_relocate($sTarget);
        exit();
    }


    //
    if (isset($_POST['save']))
    {
        //
        unset($set);
        $set["g_sStylesheet"]=DALBUM_BROWSERROOT . "main_" . @$_POST['stylesheet'] . ".css";
        $set["g_sCustomStylesheet"]=DALBUM_BROWSERROOT . "custom_" . @$_POST['stylesheet'] . ".css";
        $set["g_sCustomStylesheet"]=DALBUM_BROWSERROOT . "custom_" . @$_POST['stylesheet'] . ".css";
        $set["g_nPicturesPerPage"]=rng(1,500,@$_POST['imgTotal']);
        $set["g_nColumnsPerPage"]=rng(1,10,@$_POST['imgColumns']);

        $set["g_bShowTreeLines"]=!!@$_POST['imgTreeLines'];
        $set["g_nCommentsMode"]=rng(0,3,@$_POST["cmtEnable"]);
        $set["g_sCommentsAdminEMail"]=@$_POST["cmtTarget"];
        $set["g_sCommentsFromEMail"]=@$_POST["cmtFrom"];
        $set["g_bShowImageTitles"]=rng(0,1,@$_POST["imgShowTitle"]);
        $set["g_bShowExifLine"]=rng(0,1,@$_POST["showExifLine"]);
        $set["g_bShowHist"]=rng(0,1,@$_POST["showHist"]);
        $set["g_bShowSlideOnly"]=rng(0,1,@$_POST["showSlideOnly"]);

        $set["g_bShowOriginalImageButton"]=rng(0,2,@$_POST["showOriginal"]);
        $set["g_bShowAllImagesButton"]=rng(0,1,!!@$_POST["allowAllButton"]);

        // Save configuration
        $f=$g_sPrivateDir . "/.config.dat";
        if (!save_file($f,serialize($set)))
        {
            reportError(strtr($lang['editSaveError'],array("#filename#"=>$f)));
        }
        else
        {
            dalbum_relocate($sTarget);
        }
        return;
    }

    function rng($min,$max,$v)
    {
        $v=(int)$v;
        if ($v<$min)
            return $min;
        if ($v>$max)
            return $max;
        return $v;
    }



?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" >
<html>
<head>
<title>Configuration settings</title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php print $g_sCharset;?>">
<script src="<?php print DALBUM_BROWSERROOT . 'dalbum.js'; ?>" type="text/javascript"></script>
<link rel="stylesheet" href="<?php print $g_sStylesheet; ?>" type="text/css">
<link rel="stylesheet" href="<?php print $g_sCustomStylesheet; ?>" type="text/css" >
<style>
    td.group
    {
        font-weight: bold;
        padding-top: 20px;
        border-bottom: 1px outset white;
    }
    td.bordertop
    {
        border-top: 1px inset white;
        padding-top: 10px;
    }
</style>
</head>

<body class="centered">
<div><a name="top"></a></div>
<form action="" method="POST">

<table border="0" class="dialog" >
<tr>
    <th colspan=2>
    Configuration Settings
    <input type='hidden' name='url' value='<?php print quotehtml($url); ?>'>
    </th>
</tr>

<tr>
<td colspan=2 class="group">Colors and styles</td>
</tr>

<tr>
    <td><label for="stylesheet">Color scheme:</label></td>
    <td><select name="stylesheet" id="stylesheet">
<?php
    $dir=opendir(DALBUM_ROOT);

    // Loop through all files
    while(false !== ($file = readdir($dir)))
    {
        // Ignore hidden files
        if (preg_match('/^main_(.*?)\.css$/i',$file,$arr))
        {
            $selected="";
            if (basename($g_sStylesheet)==$file)
                $selected=" selected";
            print "<option $selected value='$arr[1]'>" . quotehtml($arr[1]) . "</option>";
        }
    }
    closedir($dir);
?>
    </select></td>

<tr>
<td colspan=2 class="group">Index page</td>
</tr>
<tr>
    <td><label for="imgTotal">Thumbnails per page:</label></td>
    <td><input size=6 type=text id="imgTotal" name="imgTotal" value="<?php print $g_nPicturesPerPage;?>"></td>
</tr>
<tr>
    <td><label for="imgColumns">Number of thumbnail columns:</label></td>
    <td><input size=6 type=text id="imgColumns" name="imgColumns" value="<?php print $g_nColumnsPerPage;?>"></td>
</tr>
<tr>
    <td><label for="imgColumns">Allow &quot;All images&quot; button:</label></td>
    <td><select name="allowAllButton" id="allowAllButton">
        <option <?php print $g_bShowAllImagesButton?"selected":"";?> value="1">Yes</option>
        <option <?php print $g_bShowAllImagesButton?"":"selected";?> value="0">No</option>
    </select></td>

</tr>

<tr>
    <td><label for="imgTreeLines">Show tree lines:</label></td>
    <td><select name="imgTreeLines" id="imgTreeLines">
        <option <?php print $g_bShowTreeLines?"selected":"";?> value="1">Yes</option>
        <option <?php print $g_bShowTreeLines?"":"selected";?> value="0">No</option>
    </select></td>
</tr>

<tr>
    <td><label for="imgShowTitle">Show image titles:</label></td>
    <td><select name="imgShowTitle" id="imgShowTitle">
        <option <?php print $g_bShowImageTitles?"selected":"";?> value="1">Yes</option>
        <option <?php print $g_bShowImageTitles?"":"selected";?> value="0">No</option>
    </select></td>
</tr>

<tr>
<td colspan=2 class="group">Image view page</td>
</tr>
<tr>
    <td><label for="showOriginal">Display link to original image:</label></td>
    <td><select name="showOriginal" id="showOriginal">
        <option <?php print ($g_bShowOriginalImageButton==2)?"selected":"";?> value="2">Yes, download</option>
        <option <?php print ($g_bShowOriginalImageButton==1 || $g_bShowOriginalImageButton==-1)?"selected":"";?> value="1">Yes, display in a new window</option>
        <option <?php print (!$g_bShowOriginalImageButton)?"selected":"";?> value="0">No</option>

    </select></td>
</tr>

<tr>
    <td><label for="showOriginal">Show line with EXIF parameters:</label></td>
    <td><select name="showExifLine" id="showExifLine">
        <option <?php print $g_bShowExifLine?"selected":"";?> value="1">Yes</option>
        <option <?php print $g_bShowExifLine?"":"selected";?> value="0">No</option>
    </select></td>
</tr>

<tr>
    <td><label for="showOriginal">Show histogram (slow):</label></td>
    <td><select name="showHist" id="showHist">
        <option <?php print $g_bShowHist?"selected":"";?> value="1">Yes</option>
        <option <?php print $g_bShowHist?"":"selected";?> value="0">No</option>
    </select></td>
</tr>

<tr>
    <td><label for="showSlideOnly">Slide show:</label></td>
    <td><select name="showSlideOnly" id="showHist">
        <option <?php print $g_bShowSlideOnly?"selected":"";?> value="1">Show image only</option>
        <option <?php print $g_bShowSlideOnly?"":"selected";?> value="0">Show image title, comment etc.</option>
    </select></td>
</tr>


<tr>
<td colspan=2 class="group">Comments</td>
</tr>
<tr>
    <td><label for="cmtEnable">Image comments:</label></td>
    <td><select name="cmtEnable" id="cmtEnable">
        <option <?php print ($g_nCommentsMode==0)?"selected":"";?> value="0">Disabled</option>
        <option <?php print ($g_nCommentsMode==1)?"selected":"";?> value="1">Anonymous users can read and comment</option>
        <option <?php print ($g_nCommentsMode==2)?"selected":"";?> value="2">Anonymous users can read only</option>
        <option <?php print ($g_nCommentsMode==3)?"selected":"";?> value="3">Only authenticated users can read and add comments</option>
    </select></td>
</tr>
<tr>
    <td><label for="cmtTarget">Send notifications to (ex. admin@mysite.com):</label></td>
    <td><input size=20 type=text id="cmtTarget" name="cmtTarget" value="<?php print quotehtml($g_sCommentsAdminEMail);?>"></td>
    <script type="text/javascript">
        //<!--
            dalbum_firstFocus();
            dalbum_setHideFocus();
        //-->
    </script>
</tr>
<tr>
    <td><label for="cmtTarget">Send notifications from (ex. admin@mysite.com):</label></td>
    <td><input size=20 type=text id="cmtFrom" name="cmtFrom" value="<?php print quotehtml($g_sCommentsFromEMail);?>"></td>
</tr>


<tr>
    <td colspan=2 style="text-align:right;" class="bordertop">
        <input type="submit" name="save"   value="<?php print $lang['editSaveBtn']; ?>">&nbsp;
        <input type="submit" name="cancel" value="<?php print $lang['editCancelBtn']; ?>">
    </td>

</tr>

</table>
</form>

<div><a href='<?php print translateRef("index.php");?>' class='pageLink' ><?php print $lang['mainPage'];?></a></div>

</body>
</html>
